
For those who want a clean to read changelog

================
Version 9 - G H
================

==General
-Added +FORCEALLYCOLLISION to team tricks
--Rock/Doc/Wave/Charge/Shade/Plug/Venus
-Added +DONTREFLECT to several class attacks
-Fixed Class Info menu jump not working
-Added/changed sounds for the following
--Crystalman big fire/bounce
--Dustman big shot death
--Springman firing
--Turboman wheel toss
-Added flight disables to the following
--Tengu alt, Bright Item, Burst Alt

==Maestro
-Fixed mugshot not showing on the scoreboard

==Roll
-Swing set explosion size 24->32
--This applies to copy version
-Health shot speed 50->41

==Auto
-Starting healing ammo 42->14
-Starting crafting ammo 120->190

==Fireman
-Health 850->1000

==Needleman
-Needle shot speed 52->60

==Geminiman
-Fixed a crash involving GeminiClone

==Darkman3
-Sniper ring speed 120->180, damage 150->90

==Darkman4
-JumpZ 10->11

==Yamatoman
-Fired spear radius/height 5->8

==Pirateman
-Reload animation duration 35->24

==Magmaman
-Large shot ammo use 12->8

==Commandoman
-Invisible wave damagers for missiles 7->5

==Solarman
-Max power suction, passive->during altfire

==Terra
-Spark Chaser hold duration halved
--Explosive damage 56->43

==Mercury
-Added missing TimeStopper pain frames

==MegaWaterS
-Starting shield ammo 4->14

==RaThor
-Grab slam now disables flight right away
--This fixes flying up to avoid the snare

================
Version 9 - G
================

==MM8BDM Related Changes
-All of the SBARINFO was converted to ACS
-Recolored sprites for cores teamcolor system
-Removed HP respawn cvars and related ACS
-Removed pickups being enabled in LMS
--Core has an option to re-enable the above
-CBM Training map removed
--Helper actor added to TRAINING instead
-Buster like shots now have a bigger hitbox
--This is due to core MegaBuster radius 5->10
-Replaced ACTRUTIL with a future fixed one for v6c
-Replaced PUAPROP with a future fixed one for v6c

==General
-Players can now move instantly upon spawning
-Grabs/snares now prevent constant dashes
--Example, Tengu escaping Shade grab
-Pit teleport disabled when holding CTFlags
-Pit protection from flings has been removed
-Increased damage from weaknesses removed
-Adjusted movement check ACS method
--Fixes controller issues for Pluto/Enker/Etc
-RageRune now adds 50% damage to boomerang attacks
--Cutman, Hardman, Ringman, Knightman, Pumpman
-SpreadRune works with more attacks, such as quakes
-Classes can now use all support items like RushJet
-SCORINFO has been adjusted, if on Zand 3.2+
--Removed handicap/playercolor/countryflag
--Added team logos to TEAMINFO for the ScoreBoard

==Copy Classes
-WepC has been removed
-Buster upgrades are usable for all copy classes
--Tweaked colors for Arrow/Laser/MegaArm
-Jet/Power Adaptor adjusted
-All Purpose Upgrade removed
--Protoman/Bass/Duo gained their upgrade
-Custom weapons are now supported
--Requires prior setup to do x10 damage
--Added support for interacting with Rock/Doc/ER
-Removed all loadout related actors/scripts

==Megaman
-Health 900->1000
-Charge shot damage 400->350, speed 26->40
-Total slide bars 5->3
-Now spawns with infinite use adaptors
--Use item to swap between modes

==Protoman
-Changed hud color to not match core ProtoBuster
-Can now do a boosted jump during slide
--Even when sliding off ledges
-Proto Strike no longer requires upgrade
--Strike no longer rips, damages once
--Does more damage at long range

==Bass
-Changed hud color to not match core BassBuster
-Removed unique TrebleBoost weapon
-Air dash no longer requires upgrade
-Can now kick upwards during a dash

==Duo
-Now resists half hitstun like Hardman
-Tackle dash is now limited to 3 uses
--Can be freely aimed and usable in the air
-Meteor replacement item now permanent
--Requires 2/3 dash ammo to be used

==Maestro
-Health 750->800

==Auto
-Added BeatCall to creation list
--Costs 60 ammo to create

==SniperJoe
-Apache skin updated by FTX6004

==Timeman
-No longer immune to TimeSlow/TimeStopper

==Metalman
-Blade radius 3->4, height 4->5
-Removed invisible blade to spawn floor shot
--Always spawns floor shot now

==Airman
-Item ammo drain when on the ground removed

==Bubbleman
-Alt attack is now more aimable vertically

==Flashman
-No longer immune to TimeSlow/TimeStopper

==Heatman
-Minor HUD animation changes
-Atomic Fire delay before firing 13->7
-Atomic Pillar delay before firing 12->8
-Tackle is now done via Altfire->Mainfire
--Can tackle on both weapons

==Woodman
-Slam set explosion size 8->24

==Hardman
-Altfire boost ammo use 3->2

==Topman
-All jump reductions during mainfire removed

==Snakeman
-Created a new SearchSnake for teamcolor
--This snake cannot climb actors

==DocRobot
-Scanner moved from altfire to item use
-Altfire on buster does nothing
-Stats applied to buster upgrades

==Pharaohman
-Shot3 fixed to not use shot2 damage
--Set explosion size 16->24

==Diveman
-Missiles now aim like Airman altfire
--Adjusted initial thrust for better aiming
-The first missile fired is now centered
-Smoke FX removed from basic missiles

==Gravityman
-Gravity Well base delay 24->12
--Delay per 256 units 8->4
--Maximum delay distance 1280->1536

==Darkman1
-Mainfire damage is correctly x10

==Blizzardman
-Can now look around during the bowl
--Due to above, can also jump during bowl

==Centaurman
-Lowered the amount alpha on CentaurFlash
-Now maintains velocity after warp

==Turboman
-Weapon states cleaned up to fix desync
-Altfire can now be used in the air
--Charges even faster on solid ground

==EvilRobot
-Rage shifted from altfire to item use
-During rage, item use will swap to base weapon
-Base weapon still performs giga attacks
-Rage drain per tic 4->3

==Dynamoman
-Hud updated by Pegg

==Groundman
-Attempted to better sync weapon states
-Removed using altfire before full ammo

==Concreteman
-Air tackle speed matches ground speed
-Tackle can now push PirateMines

==Magmaman
-Item removed, ammo regens when not moving
-Large shot ammo use 8->12

==Blademan
-Adjusted animations to 2 tic
-Holding altfire now prevents clinging
-Cling floor check limit 32->16
-Removed instant dash from wall to ground

==Commandoman
-Missile now goes to the floor on direct hits
--Direct damage 50->10, explosion damage 100->190
-Wave invisible damagers spawned 5->7

==Nitroman
-Ramming explosion size 36->48
--Ram now flings away based on velocity
--Re-hit protection 35->28

==Mercury
-Item changed to a second weapon like Mars
-Can stay in blob form when out of ammo
-Blob return height 13->32

==Mars
-Firing bloom pattern offsetted -> angled
-Missile explosion does 50 more on time out

==Uranus
-Speed 0.6->0.69
-Speed increase based on rage removed

==Pluto
-Ammo drain is now delayed by 9 tics

==BusterRodG
-Redid mainfire to work with core team colors
-Hud animations adjusted

==HyperStormH
-Added colorful sprites for mainfire

==Punk
-Rapid shot now fires like core's ScrewCrusher
--Damage 190->140

==Modding Notes (not shown internally)
-Protoman's Buster infinite shield spawning fixed
-Fixed Auto and DocRobot not working with lowered MaxHealth (Fishy)
//-Fixed CBM_TEST giving core E/MTanks
//-Fixed several healing cases that weren't x10 if scaling health was disabled
-Heatman pillar weapon frame name HEAA to HEAB
-Adjusted all pain effects to not use team colors (floor freeze/burning)
-Fixed 1/256 chance of ignoring pain (PlayerPawn default issue)
-Added cvar YD_Chaos_StartWithRune
-Adjusted A_WeaponReady on Blademan to fix weapon swap issues...again?
-FlagBearer speed increased like Hardman and friends (9-FH)
-Fakeman SBAR 'Fan The Hammer' icon added
-Timeman firing offset for fast/slow shots 8 -> -8
-Wily Capsule Ice Wep regen matches Fire Wep
-Clownman spread peg issue fixed
-"cbm_FetchMovementInput" instances changed to "cbm_IsInputingMovement"/"cbm_FetchInputDir"
--Except Solarman if that old style is ever used
-TenguIsHovering/HornetIsHovering renamed to CBM_IsHovering
-CountBomb 6/10 versions beefed up
-Removed old BreakDash copywep sprites
-Shifted Magic confetti from PCNF to MGB8 (MagicMDeath_Confetti)
//-C_CHECK_SINGLE_INPUT Cases: changed to match order of BT_ ids
//--Added a MODINPUT_BUTTONS check as an option (Mars altfire)
-MagicCard sprite offsets adjusted
-Venus bubble desync online fixed
-Crash with Darkman2 spreadrune mainfire shield fixed
-Added items AirJumpster and WallJumpster
-Adjusted ClassBase over to v6b methods
-Renamed all class weapon files/actors from RollingCutterBoss to Cutman_W
-DONTDRAIN actors removed due to core applying the flag
-Tweaked Telefog and removed edited core actors for painstates (FirePillar/TeruTeru)
--Added fire/freeze/elec/etc damagers to all related classes
-Added and removed copywep damagers
-Removed sounds/renamed SNDINFO that core is now using
-Several class flag inventory were changed to ammo for bar ACS
-GravitySlammer/BubbleFlood now use core aprop_powers for gravity changes
--Shifted slam actors to their weapon files
-Removed mugshots that are now in core
-Removed invis team icons for Shadow/Drill/Search/Ground
-Changed Swordman/BusterRodG user_variable use to Args
-Somehow edited Iceman alt to match changed skin
-Added pixel to Flameman's pain frame
-Woodman idle frames made to match adjusted skin
-Groundman walk frames updated. (Thanks Pegg!)
-Changed all instances of sqrt8 usage in ACS to VectorLength
-Almost every class projectile sprite is colored normally
--Removed unneeded Cyan/Blue sprites due to above
-Removed StaminaFlag and Resolidifier actors due to core using them
--Adjusted all uses of resolid to use core's scripts
-Adjusted death states of the classbase due to core changes
--Adjusted class death states and attempted fixes to make them work
-Removed hop on spawn user cvar due to core copying NOGRAVITY on spawn
-Fixed -1 dimamount in menu due to Zand menu logic changes (cannot manually do -1)
-"PITFIND.acs" has been removed. Long live "core_checkPit"
-Adjusted JupiterBeam due to it relying on desync to fire online (color issue)
-Removed Chillman's shield ACS and replaced it with 99% armor.
---Dev note: It was possible to keep it working, however due to possible increased healing via
---new things and the hit sounds, it would just lead to more confusion to both the user and foes.
-Added Massacre damagetype to the pit teleports
-Removed Chillman's 99% armor and replaced it with an EVENT script
-Increased the radius of many buster like projectiles due to core changing MegaBuster shot radius 5->10
--Full list of every exact change at the bottom of the internal changelog
-"C_CHECK_TARGET_OOC" and friends removed, "use cbm_PointerExists instead" (core version is different!)
-Added Trillster's FAKEWEP wrapper ACS (For Snatcher classes and RockClass)
-Added a weapon define system for Rock/DocRobot/Evilrobot's systems
-Proto/Bass rush actors are no longer seperate items
--They will still show up when rush coil/jet/marine is used by them
-Plantman drain changed to use the drainrune stacker
-Shademan changed to use drainrune stacker rather than flat heals
--However since drain is 75%, Shade always heals at least 10hp per hit
-FlagBearer no longer uses clearinventory so everything in core doesn't break
-Replaced several class flags to use Vivify flags if possible (Bearer)
-Adjusted all instances of Rage/Spread rune checks to core flags/scripts
--Fixed several instances of old rage/spread checks being swapped
--Added more checks for spread on many instances of single damaging actors
-Added copies of ArrowBuster/LaserBuster/MegaArm to tweak their hud frames from basic buster colors
-Adjusted core BassBuster's spread, removed the refire delay, and added a proper cooldown
-Added the TargetMarker changes from core
-Added missing blink frames to Power/Jet Mega skins
-Suffered adjusting Shadowman's skin, nothing can be done for fire frames
-Stoneman skin colors adjusted back to core colors and 'core' to skin colors
-Applied similar flag cleanup from CTF morph to possession pickup
-Added check to prevent flash state disable in possession for select classes
-Search hud updated by Pegg (tweaked hold/fire frames [Cel])
-DocRobot's class scanner and DocScannerWep is now dynamic
--Custom weapons/classes can be added to the array to hand out the weapons
---Check "CBM_DEFS.acs" to see how they are added
-Set up a copynerf stacker for modders to add their own damage reductions for their copy weapons
-"cbm_sv_allowsnatching" and related actors removed. (It was a good attempt)
-Replaced FAKEWEP acs with different Rock ball tricks.
-Health/Ammo can be snatched again
-Doc/ER ammo tricks now work with ammo2 on custom weapons
-Swapped DocScanner actors so DocScannerWep is the original
-Further tweaks to FAKEWEP to prevent ItemFog on pickup
-Removed all old bar/var TEXTURES/ANIMDEFS that are in the new system
-Adjusted several CBM acs to Core acs. They are within "LEGACY.acs"
-All classes now [player.startitem "CBM_BaseFlagPack"] due to the ENTER script being delayed with lag
-Rearranged ClassBase so Weakness damagetypes are at the start
--This allows for custom weapons to 'goto' specific damagetypes for weakness sounds
-Removed increased damage weaknesses, sounds are still there
-Changed poison (afterburn) methods to a different style (DrLight/DrWily/Rock)
-Updated floor quakes to an adjusted method from Unholy
--Copied Unholy Handyman's quake FX tricks
//-Attempted redoing EvilRobot laser to be more precise
//--...ACS cannot handle it, clientside fade issues
-Adjusted most? TID uses to use negative TID (Sword camera/Magicman warp)
--Added CBM's used TIDs to Core reserve TID tricks
-After several days, fixed EvilRobot's laser to work online
-For some reason changing Gemini Clone ACS to use similar core ACS completely broke it
--Cleaned Gemini Clone decorate/ACS due to above
-Added additional flag resets to after FlagBearer demorph
-Adjusted the join game menu. Modders don't need to change it anymore
-Added 'HasSemiStunArmor' to all classes that spawn with it for morph/demorph take/give
-Adjusted core Beef actors to have +SKYEXPLODE and use Args[] for explosions
--Most core projectiles should now properly interact with the sky
-Applied +SKYEXPLODE to most projectiles that explode/bounce/special death tricks
--This is done so they work on the sky. Such as Ballade's shot VS a Gravityman on the sky
-Fixed a strange issue where Roll's bucket shots caused severe FPS lag???
-Fixed SniperJoe going into the 4th dimension with multiple crates
-Added "cbm_aimattargetcursor", an edit of core's to allow negative TIDs
-Further sweep through so more attacks work with SpreadRune, such as PlugDrain or DocScanner
-Adjusted similar attacks to use cores new sounds, such as FreezeCracker and FlashBomb
-Added "cbm_knockback", edit of core's to allow ThrustThingZ to not reset velocity
-Adjusted all pain fling aways to above script
-Removed redundancy for give enemy item on pain
--Moved pain gives/flings from "ClassBaseTID.txt" to their respective class weapons
-Removed 'BossFlashStopperedStop', use 'EternalPainFlag' instead
-Added "cbm_countinv_acs_ptr", to check a pointer's pointer
-Fixed "HealThingMod.txt" actors not healing properly
-Ported Trillster's "Hero Megaman" with adjustments
-Removed Bass TrebleBooster actors
-Moved all class bar actors from "ClassBarZone.txt" to the bottom of their weapon files
-Fixed Chillman ACS not loading properly and the watcher stacking in CTF/Skulltag (ACS File names)
-Shifted over all 'classhelp' ACS strings to LANGUAGE.TIPS
--Updated tips and removed outdated notes
-Renamed Semi/StunArmor to 'HalfHitStunFlag'/'NoHitStunFlag'
-Added 'HalfPushFlag' to match cores 'NoPushFlag'
--Changed all use of Semi/StunArmor to ACS calls like PROPUTIL
-Most pain flings now respect 'HalfPushFlag' and 'NoPushFlag'
-Fixed several special death states for classes
-Shifted files around/renamed, such as ClassBaseFlags
-Reorganized Graphics folder
-'NoPushFlag' added to SniperJoe crate/Drillman alt/Groundman alt
-Fixed a strange case where players always gibbed on unknown death states
-Further work on CTF morph and demorph
-Tweaked "HITSOUND.acs" to limit crits to 500 damage at most
-Added 4 tic delay Alpha fix to Possession script (Galaxy?)
-Added "sv_weapondrop = true" to GAMEMODE...
--Removed the above, causes issues for hosts
-Removed Timeman alt powerup icon, tweaked hud/bar color
-Pirateman's face is team colored
-Applied several white/black color suggestions/fixes from Trillster
-Replaced TimeStop frames for a few classes
-Added "CBMTUTOR.ACS", a copy of CBM_TEST ACS with improvements
--Spawns an actor on TRAINING to execute everything
-Added several debuff/buffs to PowerAprop systems for morphes
--This includes copies of core TimeSlow/SparkShock
-Fixed pain conflict issues for wait until hit tricks (Burst bubble)
--Fixed classes with alternate ClassPain states not breaking free from TimeBender on hit
-IsInPain repurposed for delayed pain FX. Use EternalPainFlag instead
-Updated GoldenNapalmBombWep [For campaign's MM6 Boss fight]
-Removed "0.001" from SavePercent on all armor pickups
-Fixed Auto's ETank healing less than intended
-Added something more fitting to weapon despawn
-The following files had projectiles changed from ThrustThingZ to A_ChangeVelocity on spawn
--FragBomber, FlashBulb, PlantTrapper, Rock, Roll, SniperJoe, Guts, Ice, Bomb,
-- Oil, Bubble, Heat, Wood, Alien, Needle, Spark, Shadow, Bright, Charge, Napalm,
-- Darkman1, Plant, Junk, Spring, Slash, Tengu, Frost, Grenade, Aqua, Burner, Magic,
-- Concrete, Splash*, Hornet, Commando, Chill, Nitro, Solar, Mercury, Uranus, YellowDevil
-"core_checkPit" -> "cbm_checkDamagingPit" to allow flying over dynamic pits
-Added attempted failsafe for pit teleport, teleporting you into a pit
--It will call core's ExitUnit script to teleport back to spawn
-Shadowman can use Crypt Blocks in Rock Force pack
-Changed GeminiClone double damage damagefactor to a pickup
-Cleaned up "cbm_legacyDustPull" to remove redundancy
-Renamed ACS "C_DIVELOCKDISPLAY" [4407] to "cbm_DiveLockDisplay"
-Removed scripts 522, 4004, and 4707. Use "cbm_GetPlayerButtonInput" or "cbm_GetPointerButtonInput"
--"C_JAX_CHECK_JUMP", "C_CHECK_SINGLE_INPUT", "C_CHECK_TID_JUMP"
-Shifted Splashwoman's buffs to the assist display system
-CBM_GENERAL.acs shifted to CBMACSHR.acs and CBM_TOOLS.acs
-CBM_SPECIFIC.acs split apart into seperate CBMACS_#.acs
-Script 812 renamed to "cbm_GradualAngleTurn"
--Improved the angle precision so its not solid angle integers
-Removed C_JAX_SPECTRUM scripts 444/445/446
-"C_JAX_SUCKRECODE" [422] renamed to "cbm_ConedPushPull"
-Renamed "cbm_legacyDustPull" to "cbm_ThrustNearbyPlayers"
-Added 'CBM_ShootableActor' and slots like core ClassBase
--Modders can add DamageFactors they want shootable objects to resist/ignore
-Fixed Joe colors for crate->apache
--Joe has NOGRAV during Crate Menu
--Cleaned up flag management, removed some flags
-$$$ Beginning going through every class to adjust infinite ammo/missed rage/spread
-Fixed pixels on several Auto Hud frames
--Combined hud sprites so right arm isn't displayed via Flash state
-Changed DrLight stamina management to match Mega/Proto/etc
-Extra infinite ammo adjustments done to the following classes
--DrWily, SniperJoe, Bubble/Splash, Flash, Drill, Gravity, 
--Tengu, Ground, Splash, Nitro, Venus, RaThor
-Junkman hud combined and flash state animations removed
-Adjusted Mercury from item -> weapon swap, uses PreferredSkin now
-$$$ Finished going through every class to adjust infinite ammo/missed rage/spread
-Changed Crystalman secondary color cyan->white due to skin changes
-Changed BBA's teamcolors and corpse colors and fixed DYE numbers
-Changed Doom 1 chat sound from Temmie voice to MM7/MMB chatter sounds
-Shifted several class specific hud icons to the top right corner
-Added 'DefaultPropertiesSet_F' to help support "PUAPROP.acs" fixes







//These actors had their radius increased since
//core increased MegaBuster/BassBuster radius from 5>10
/*
```
HyperStormBlasterBullet 8->10
ProtoShotC 5->10
MegaShotC 5->10
PowerShot 8->10
PowerShot2 12->14
MaestroShot 5->10
RollCleanserShot 9->10
BassShotB 5->10
BoostCShot 7->10
AutoScrewShot 5->10
AutoScrewShot2 14->16
JoeShot 6->10
JoeGrenade 8->11
Apacheshot 10->12
MGunJoeShot 6->10
BBA_PistolShot 6->10 (All bullets copy this)

BubProj 6->9
FlashBullet 6->10

NeedleM_CannonShot 6->9
BossGeminiLaser 5->8
GemShot 5->10
DocShotB 7->10

BrightShot 6->10
DustCrusherDust 12->14
DustBit1Dust 7->9
DustBitPew 8->10
DustShot 6->10
SkullShot 6->10

GravityShot 8->10
WaveHarpoon 8->10

CentaurShot 7->10
CentaurShotBit 6->9
PlantShot 5->10

CopyShot_Astro 5->10 (also height 5->10)
Grrnade 6->11 (fragbomber)

RevolverShot 6->10

MarsVulcanShot 6->8

MWS_Harpoon 7->9
QShot 5->10
```

*/
//These actors had their speed increased due to core increasing MegaBuster's speed from 27->35
/*
All increased to 35 speed

ProtoShotC 27
ProtoShot2C 26
Megaman_Shot1 27
Megaman_Shot2 26
MaestroShot 27
QShot 32
*/






//////////////////////////
#Older Changelog Links////
//////////////////////////

//classes-v9g
# pastebin.com/raw/ZKimQsa8

//classes-v9fh
# pastebin.com/raw/NMHVf6fV

//classes-v9eh
# pastebin.com/raw/eSdNyiNK

//classes-v9dh
# pastebin.com/raw/z2NYbGpY

//classes-v9ch
# pastebin.com/raw/Vfh1nFWC

//classes-v9b
# pastebin.com/raw/1TCeREgv

//classes-v9a beta5 (April Fools Unholy version)
# pastebin.com/raw/CyyHbBxi

//classes-v9a (beta1 >> beta5)
# pastebin.com/raw/85P4GSMB

//classes-v8e
# pastebin.com/raw/K8W6Fu8Y



